import ru.ifmo.testlib.*;
import ru.ifmo.testlib.Outcome.Type;

public class Check implements Checker {

	@Override
	public Outcome test(InStream inf, InStream ouf, InStream ans) {
		int n = inf.nextInt();
		inf.nextLong();
		int k = inf.nextInt();
		for (int i = 0; i < k; i++)
			inf.nextInt();
		
		double[] x = new double[n + 1];
		double[] y = new double[n + 1];
		for (int i = 0; i < n; i++) {
			x[i] = inf.nextLong();
			y[i] = inf.nextLong();
		}
		
		double perimeter = 0;
		for (int i = 0; i < n; i++) {
			perimeter = perimeter + Math.sqrt(((double)x[i] - x[i + 1]) * ((double)x[i] - x[i + 1])  + ((double)y[i] - y[i + 1]) * ((double)y[i] - y[i + 1])); 
		}
		
		double pAns = ouf.nextDouble();
		double jAns = ans.nextDouble();
		double diff = Math.abs(jAns - pAns);
		
		if (diff > perimeter * 1e-6)
			return new Outcome(Type.WA, "Wrong answer: jury: " + jAns + ", participant: " + pAns);
		else
			return new Outcome(Type.OK, "OK");
	}

}
